// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################

// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de
// l'étallonnage du touchepad décrite dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Etalonnage.html

// Ce programme permet d'étalonner le touchpad.

#include <PecheuxGraph.h>

void setup()
{
  int x, y, oldx = -1, oldy;
  long x1, y1, x2, y2; // Coordonnés des deux points extrèmes
  long somme, difference; // Variables intermédiares pour faire les calculs
  setGraphMode(PAYSAGE); // Paysage impératif

  text(F("Vérification de l'étallonnage\nDéplacez le stylet sur l'écran"));
  setTextCursor(7, 220); // Dessin d'un bouton
  text(F("Suite"));
  rect(0, 214, 58, 239);
  do // Bouclage tant qu'on regarde la croix se déplacer
  {
    if (isTouch())
    {
      x = getTouchX(); y = getTouchY();
      if (x != oldx) // pour éviter le papillottement; on efface que si c'est utile
      {
        vLine(oldx, 0, oldx > 58 ? 239 : 213, BLACK); // Efface l'ancienne verticale
        oldx = x;
        vLine(oldx, 0, oldx > 58 ? 239 : 213, WHITE); // Dessine là où est le curseur
      }
      if (y != oldy)
      {
        hLine(oldy < 214 ? 0 : 59 , 319, oldy, BLACK); // Efface l'ancienne horizontale
        oldy = y;
        hLine(oldy < 214 ? 0 : 59 , 319, oldy, WHITE); // Dessine là où est le curseur
      }
    }
  }
  while ((x >= 58) || (y <= 214)); // Fin quand le stylet est sur le bouton Suite



  // Croix en haut à gauche
  clrscr();
  hLine(0, 20, 10); vLine(10, 0, 20);
  setTextCursor(40, 3); text("<-- Cliquez sur la croix");

  // Lecture du point de contact 1
  while (!isTouch());
  delay (200);
  x1=y1=0;
  for (byte nbLectures = 0; nbLectures < 16; nbLectures++) // On va faire la moyenne de 16 mesures
  {
    while (!isTouch());
    x1 += getTouchX(); y1 += getTouchY();
  }
  x1/=16; y1/=16; // Moyennes
  clrscr();


  // Croix en bas à droite
  hLine(300, 319, 230); vLine(310, 219, 239);
  setTextCursor(60, 220); text("Cliquez sur la croix -->");
  delay (1000);

  // Lecture du point de contact 2
  while (!isTouch() || (isTouch() && (getTouchX() < 160)));
  delay (200);
  x2=y2=0;
  for (byte nbLectures = 0; nbLectures < 16; nbLectures++) // On va faire la moyenne de 16 mesures
  {
    while (!isTouch());
    x2 += getTouchX(); y2 += getTouchY();
  }
  x2/=16; y2/=16; // Moyennes
  clrscr();

  // Calcul des nouvelles constantes, j'explique pas, j'ai tatonné...
  difference = ((TOUCH_X_MAX - TOUCH_X_MIN) * (x1 - x2)) / 300;
  somme = TOUCH_X_MIN + TOUCH_X_MAX + ((x1 + x2 - 320) * (TOUCH_X_MAX - TOUCH_X_MIN)) / (x2 - x1);
  x1 = (somme - difference) / 2;
  x2 = (somme + difference) / 2;

  difference = ((TOUCH_Y_MAX - TOUCH_Y_MIN) * (y1 - y2)) / 220;
  somme = TOUCH_Y_MIN + TOUCH_Y_MAX + ((y1 + y2 - 240) * (TOUCH_Y_MAX - TOUCH_Y_MIN)) / (y2 - y1);
  y1 = (somme - difference) / 2;
  y2 = (somme + difference) / 2;

  // Affichage du résultat
  text("Dans le fichier PecheuxGraph.h,\nmodifiez pour avoir:");
  text("\n#define TOUCH_X_MIN " + String(x2) + "L");
  text("\n#define TOUCH_X_MAX " + String(x1) + "L");
  text("\n#define TOUCH_Y_MIN " + String(y2) + "L");
  text("\n#define TOUCH_Y_MAX " + String(y1) + "L");
}

void loop()
{
}
