// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction writeData8() décrite dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/writeData8Exemple.html

// Ce programme montre qu'avec les fonctions de bas niveau, on arrive à toutes les possibilités du driver

#include <PecheuxGraph.h>

void setup() 
{
  setGraphMode(PAYSAGE); // Obligatoire pour utiliser l'afficheur
  // Affichage d'un fond d'écran. En BPX parce que cela va plus vite.
  if (
  bpxDraw("320x240/1.bpx",0,0)* // Affiché seulement en mode paysage
  bpxDraw("240x320/20.bpx",0,0) // Affiché seulement en mode portrait}
  !=0) // On n'a pas pu dessiner une image, on dessinr n'importe quoi
  for (int y=0; y<HAUTEUR; y+=10) for (int x=0; x<LARGEUR; x+=10) fillRect(x, y, x+10, y+10, random(WHITE));

  // Un premier exemple d'accès aux registres de l'afficheur: lecture du code du pilote
  byte pilote1, pilote2; // ID du pilote
  setTextSize(9); setTextBold(6); // Ecrire en gros
  setTextCursor(DEMI_LARGEUR-180/2, // 4 caractères font en moyenne 4*5*textSize=180 de large, on les met au centre 
             DEMI_HAUTEUR-63/2); // Les caractères font 7*textSize=63 de haut, mis au centre
  writeRegister(0x00); // Envoi de la commande D3 (ID code?)
  // Lecture préalable des codes, text() faisant appels aux registres
  pilote1=dataRead8Bits(); // Poids forts à lire à lire
  pilote2=dataRead8Bits(); // Poids faibles à lire à lire
  text(String(pilote1, HEX)); // Poids forts en hexadécimal!
  text(String(pilote2, HEX)); // Poids faibles en hexadécimal!
}


void loop()
{
  // Un deuxième exemple d'accès aux registres de l'afficheur
  writeRegister(0x07); // Display Control 1, CL, Display RGBcolor, Mode 8 couleurs OFF
  writeData16(0x133);
  delay(2000);

  writeRegister(0x07); // Display Control 1, CL, Display RGBcolor, Mode 8 couleurs ON
  writeData16(0x13B);
  delay(2000);
}
