// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction
// scanEvent() décrite dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/scanEventExemple.html


// Pour la seule fois, il ne faut pas d'afficheur!

// Un timer est mis en place et change l'état de la led 13 chaque seconde
// c'est scanEvent() qui met à jour le timer

#include <PecheuxGraph.h>

void changeLed(void) // Appelée toutes les secondes par le timer, elle change l'état de la led
{
  digitalWrite(LED_BUILTIN, !digitalRead(LED_BUILTIN)); // Lit la valeur et renvoi l'opposé
}


Clock horloge(1000); // Création d'une horloge 10 dixièmes de secondes soit une seconde

void setup() 
{
  pinMode(LED_BUILTIN, OUTPUT); 
  horloge.onTimeFunction = &changeLed; // dessine la droite à chaque comptage
}


void loop()
{
  scanEvent(); // C'est le moteur des événements (temporels et touchpad)
}
