// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// Clock décrites dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/ClockExemple.html

// Mise en place d'un métronome. Toutes les 2s, il change la couleur du fond
// de l'écran

// Version 6:
// - On définir une classe Metronome, dérivée de Clock, avec le bon comportement
// - Metronome a une définition dynamique dans une fonction

#include <PecheuxGraph.h> // Appel de la bibliothèque 


class Metronome: public Clock // Nouvelle classe pour redéfinir onTime
{
  public:
    Metronome(unsigned long intervalle): Clock(intervalle) {} // Constructeur qui copie la classe mère
    virtual void onTime(void) // Nouveau comportement
    {
      clrscr(RANDOM_COLOR); // Action à faire chaque seconde
    }
}; // Ne pas oublier le ; à la fin de la déclaration d'une classe


void setup()
{
  setGraphMode(PAYSAGE); // Pour pouvoir utiliser clrscr()
  
  // Déclaration dynamique de l'instance, peut se faire dans une fonction
  // Dans ce cas l'instance est accessible partout, mais le pointeur
  // horloge sera détruit en sortant de la fonction (ici du setup())
  Metronome *metronome = new Metronome(2000); // Déclaration  d'un métronome, action toutes les 2 secondes
}


void loop()
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans loop()
}
