// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// Timer décrites dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/TimerExemple.html

// Mise en place de deux temporisateur. L'un colorie l'écran au bout de 3
// secondes, l'autre efface l'écran au bout d'une demi-seconde. Il se déclenche
// l'un l'autre. Du coup, l'écran se colorie une seconde, s'éteint deux...

#include <PecheuxGraph.h> // Appel de la bibliothèque 

 
// Déclarations statique des instances
Timer temporisateurQuiAllume(3000); // Déclaration  d'un temporisateur, qui attendra 3s avant d'allumer l'écran
Timer temporisateurQuiEteint(500); // Déclaration  d'un temporisateur, qui attendra 1/2s avant d'éteindre l'écran


// Déclaration des fonctions qui feront ce qu'il faut faire toutes les fin de comptage
void fautAllumer(void) // Action à faire au bout de 3s
{
  clrscr(RANDOM_COLOR); // Allume l'écran
  temporisateurQuiEteint.start(); // Démarre son copain
}
void fautEteindre(void) // Action à faire au bout d'une demi-seconde
{
  clrscr(); // Eteint l'écran
  temporisateurQuiAllume.start(); // Démarre son copain
}


void setup()
{
  setGraphMode(PAYSAGE); // Pour pouvoir utiliser clrscr()

  // Associations des fonctions
  temporisateurQuiAllume.onTimeFunction=&fautAllumer;
  temporisateurQuiEteint.onTimeFunction=&fautEteindre;

  // Déclenchement la première fois d'un temporisateurs. Par défaut, ils sont désactivés.
  // Quand, l'un s'arrête, il se désactive et active son copain. Par contre il faut initier
  // la boucle
  temporisateurQuiAllume.start();
}


void loop() 
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans loop()
}
