// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################

// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// CheckZone décrites dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/CheckZone.html

// L'intérieur d'une maison est dessinée. Deux boutons de type CheckZone 
// permettent d'allumer la lumière. Ce sont des va et vient (boutons à 2
// positions comme les cases à cocher)

#include <PecheuxGraph.h>

// Déclaration statique des instances, doit se faire en dehors du setup
// Dans ce cas les boutons sont accessibles partout
CheckZone bouton1(186, 124, 212, 152); // Définit une zone cliquable à droite
CheckZone bouton2(8, 124, 34, 152); // Définit une zone cliquable à droite

// Déclaration d'une fonction qui fait ce qu'il faut faire à chaque changement
// Cette fonction ne doit pas avoir de paramètres et ne doit rien retourner
// Le nom peut être quelconque
// Cette fonction allume ou éteint la lampe. Elle est allumée si un seul des
// deux boutons est actif. C'est pour celaqu'on utilise le ou-exclusif ^
void lampe()
{
  fill(160, 30+1, bouton1.isSelected() ^ bouton2.isSelected() ? YELLOW : BLACK); // La lampe copie l'état des boutons
}


void setup()
{
  bouton1.onSelectFunction = &lampe; // Change l'état de la lampe si on active le bouton de droite
  bouton2.onSelectFunction = &lampe; // Change l'état de la lampe si on active le bouton de gauche
  bouton1.onUnselectFunction = &lampe; // Change l'état de la lampe si on désactive le bouton de droite
  bouton2.onUnselectFunction = &lampe; // Change l'état de la lampe si on désactive le bouton de gauche

  setGraphMode(PAYSAGE); // Initialisation

  // Consigne
  setTextCursor(10, 200);
  text(F("Appuyez sur un bouton de\n  chaque côté de la fenêtre"));

  maison(1,1); // avec 2 boutons
}

void loop()
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans le loop
}
